"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateTypeCode = void 0;
var ts = __importStar(require("typescript"));
var typescript_1 = require("typescript");
function generateTypeCode(routes) {
    var hasSlugsRoutes = routes.filter(function (route) { return route.slugs; });
    return [
        typescript_1.factory.createTypeAliasDeclaration(undefined, [typescript_1.factory.createModifier(ts.SyntaxKind.ExportKeyword)], typescript_1.factory.createIdentifier('UseParamsType'), undefined, typescript_1.factory.createTypeLiteralNode(hasSlugsRoutes.map(function (route) {
            return typescript_1.factory.createPropertySignature(undefined, typescript_1.factory.createComputedPropertyName(typescript_1.factory.createStringLiteral(route.path)), undefined, typescript_1.factory.createTypeLiteralNode(route.slugs.map(function (slug) {
                return typescript_1.factory.createPropertySignature(undefined, typescript_1.factory.createComputedPropertyName(typescript_1.factory.createStringLiteral(slug.name)), undefined, typescript_1.factory.createKeywordTypeNode(ts.SyntaxKind.StringKeyword));
            })));
        }))),
    ];
}
exports.generateTypeCode = generateTypeCode;
